import { IOptions } from "./Options/Interfaces/IOptions";
import { Container } from "./Core/Container";
import { IShapeDrawer } from "./Core/Interfaces/IShapeDrawer";
import { ShapeDrawerAfterEffectFunction, ShapeDrawerDestroyFunction, ShapeDrawerDrawFunction, ShapeDrawerInitFunction, RecursivePartial, SingleOrMultiple } from "./Types";
import { IPlugin } from "./Core/Interfaces/IPlugin";
import { Particle } from "./Core/Particle";
import { IMovePathGenerator } from "./Core/Interfaces/IMovePathGenerator";
export declare class MainSlim {
    private "MainSlim.#private";
    constructor();
    init(): void;
    loadFromArray(tagId: string, options: RecursivePartial<IOptions>[], index?: number): Promise<Container | undefined>;
    load(tagId: string, options: SingleOrMultiple<RecursivePartial<IOptions>>): Promise<Container | undefined>;
    set(id: string, element: HTMLElement, options: RecursivePartial<IOptions>): Promise<Container | undefined>;
    loadJSON(tagId: string, pathConfigJson: SingleOrMultiple<string>, index?: number): Promise<Container | undefined>;
    setJSON(id: string, element: HTMLElement, pathConfigJson: SingleOrMultiple<string>, index?: number): Promise<Container | undefined>;
    setOnClickHandler(callback: (e: Event, particles?: Particle[]) => void): void;
    dom(): Container[];
    domItem(index: number): Container | undefined;
    addShape(shape: string, drawer: IShapeDrawer | ShapeDrawerDrawFunction, init?: ShapeDrawerInitFunction, afterEffect?: ShapeDrawerAfterEffectFunction, destroy?: ShapeDrawerDestroyFunction): void;
    addPreset(preset: string, options: RecursivePartial<IOptions>, override?: boolean): void;
    addPlugin(plugin: IPlugin): void;
    addPathGenerator(name: string, generator: IMovePathGenerator): void;
}
